/*** Copyright (c), The Regents of the University of California            ***
 *** For more information please refer to files in the COPYRIGHT directory ***/
/* fileCreate.h - This file may be generated by a program or script
 */

#ifndef FILE_CREATE_H__
#define FILE_CREATE_H__

/* This is a low level file type API call */

#include "rcConnect.h"
#include "fileOpen.h"

typedef fileOpenInp_t fileCreateInp_t;

typedef struct {
    char file_name[ MAX_NAME_LEN ];
} fileCreateOut_t;

#define fileCreateOut_PI "str file_name[MAX_NAME_LEN];"


#if defined(RODS_SERVER)
#define RS_FILE_CREATE rsFileCreate
#include "rodsConnect.h"
/* prototype for the server handler */
int
rsFileCreate( rsComm_t *rsComm, fileCreateInp_t *fileCreateInp, fileCreateOut_t** );
int
_rsFileCreate( rsComm_t *rsComm, fileCreateInp_t *fileCreateInp,
               rodsServerHost_t *rodsServerHost, fileCreateOut_t** );
int
remoteFileCreate( rsComm_t *rsComm, fileCreateInp_t *fileCreateInp,
                  rodsServerHost_t *rodsServerHost, fileCreateOut_t** );
#else
#define RS_FILE_CREATE NULL
#endif

/* prototype for the client call */
#ifdef __cplusplus
extern "C" {
#endif
int
rcFileCreate( rcComm_t *conn, fileCreateInp_t *fileCreateInp, fileCreateOut_t** );
#ifdef __cplusplus
}
#endif


#endif  // FILE_CREATE_H__
